module.exports = {
    friendlyName: "Find",

    description: "Find Information User.",

    inputs: {
        codeClasse: {
            type: "string",
            require: true
        },
        anneeScolaire: {
            type: "string",
            require: true
        },
        codeEnseignant: {
            type: "string",
            require: true
        }
    },

    exits: {
        notFound: {
            statusCode: 404
        },
    },

    fn: async function (inputs, exits) {
        const { id, user } = this.req.token;
        //console.log("ID", id, user.login, user.typeUser, user.codeEcole)
        //console.log("INPUTS", inputs)
        // VERIFICATION DU CODE ECOLE
        if (user.codeEcole === '' || user.codeEcole === null || user.codeEcole === undefined) {
            return exits.notFound({ message: "Veuillez préciser le code Ecole pour cet utulisateur pour a accéder a cette page!" })
        }
        ecoleVerif = await Ecoles.find({ codeEcole: user.codeEcole }).then(_.first)
        if (!ecoleVerif) {
            return exits.notFound({ message: "Cet utilisateur n'est attribué a aucune classe!" })
        }
        // FIN VERIF CODE ECOLE

        // VERIF SI ANNEE SCOLAIRE EST PASSEE
        console.log("Annee Scolaire", inputs.anneeScolaire)
        if (inputs.anneeScolaire === '' || inputs.anneeScolaire === null || inputs.anneeScolaire === undefined) {
            return exits.notFound({ message: "Veuillez préciser une année scolaire pour a accéder a cette page!" })
        }
        ///aFIN

        if (inputs.codeClasse === '' || inputs.codeClasse === null || inputs.codeClasse === undefined) {
            return exits.notFound({ message: "Veuillez une classe pour a accéder a cette page!" })

        }
        if (inputs.codeEnseignant === '' || inputs.codeEnseignant === null || inputs.codeEnseignant === undefined) {
            return exits.notFound({ message: "Veuillez préciser un enseignant pour a accéder a cette page!" })

        }
        //////FIN

        let userCodeEcole;
        if (user.typeUser === 'ENSEIGNANT') {
            userCodeEcole = user.codeEcole
        } else {
            return exits.notFound({ message: "Vous n'etes pas autoriser a accéder a cette page!" })

        }

        let matiere = await EnseignantsClasse.find({
            codeEcole: userCodeEcole,
            codeEnseignant: inputs.codeEnseignant,
            codeClasse: inputs.codeClasse,
            anneeScolaire: inputs.anneeScolaire ? inputs.anneeScolaire : undefined,
         }).then(_.first);




        // All done.
        return exits.success(matiere);
    },
};
